#include <X11/Xlib.h>
#include <stdio.h>
#include "TPager.h"

SendChangeLine(Display *display, struct PAGER *Pager, int line)
{
	Atom				Aline;
	XClientMessageEvent	cm;

	Aline = XInternAtom(display, "Pager-line", False);

	cm.type = ClientMessage;
	cm.display = display;
	cm.window = Pager->window;
	cm.message_type = Aline;
	cm.format = 32;
	cm.data.l[0] = line;
	XSendEvent(display, Pager->window, False, NoEventMask, &cm);
}

SendScrl(Display *display, struct PAGER *Pager, int direction)
{
	Atom				Aroll;
	XClientMessageEvent	cm;

	Aroll = XInternAtom(display, "Pager-scroll", False);

	cm.type = ClientMessage;
	cm.display = display;
	cm.window = Pager->window;
	cm.message_type = Aroll;
	cm.format = 32;
	cm.data.l[0] = direction;
	XSendEvent(display, Pager->window, False, NoEventMask, &cm);
}

SendHalfPage(Display *display, struct PAGER *Pager, int direction)
{
	Atom				AHalfPage;
	XClientMessageEvent	cm;

	AHalfPage = XInternAtom(display, "Pager-HalfPage", False);

	cm.type = ClientMessage;
	cm.display = display;
	cm.window = Pager->window;
	cm.message_type = AHalfPage;
	cm.format = 32;
	cm.data.l[0] = direction;
	XSendEvent(display, Pager->window, False, NoEventMask, &cm);
}


SendPage(Display *display, struct PAGER *Pager, int direction)
{
	Atom				APage;
	XClientMessageEvent	cm;

	APage = XInternAtom(display, "Pager-Page", False);

	cm.type = ClientMessage;
	cm.display = display;
	cm.window = Pager->window;
	cm.message_type = APage;
	cm.format = 32;
	cm.data.l[0] = direction;
	XSendEvent(display, Pager->window, False, NoEventMask, &cm);
}

SendDrawScrlbar(Display *display, struct PAGER *Pager)
{
	Atom				A;
	XClientMessageEvent	cm;

	A = XInternAtom(display, "Scroll-DrawScrollBar", False);

	cm.type = ClientMessage;
	cm.display= display;
	cm.window = Pager->window;
	cm.message_type = A;
	cm.format = 32;
	cm.data.l[0] = 1000000 * Pager->pos / (Pager->lines - Pager->LINES);
	XSendEvent(display, Pager->window, False, NoEventMask, &cm);
}

SendChangeText(Display *display, struct PAGER *Pager, int TextNo)
{
	Atom				A;
	XClientMessageEvent	cm;

	A = XInternAtom(display, "Main-ChangeText", False);

	cm.type = ClientMessage;
	cm.display= display;
	cm.window = Pager->window;
	cm.message_type = A;
	cm.format = 32;
	cm.data.l[0] = TextNo;
	XSendEvent(display, Pager->window, False, NoEventMask, &cm);
}

SendExit(Display *display, Window window)
{
	Atom				A;
	XClientMessageEvent	cm;

	A = XInternAtom(display, "Main-Exit", False);

	cm.type = ClientMessage;
	cm.display= display;
	cm.window = window;
	cm.message_type = A;
	cm.format = 32;
	XSendEvent(display, window, False, NoEventMask, &cm);
}

SendReturn(Display *display, Window window)
{
	Atom				A;
	XClientMessageEvent	cm;

	A = XInternAtom(display, "Main-Return", False);

	cm.type = ClientMessage;
	cm.display= display;
	cm.window = window;
	cm.message_type = A;
	cm.format = 32;
	XSendEvent(display, window, False, NoEventMask, &cm);
}

SendXK(Display *display, Window window, KeySym key)
{
	Atom				A;
	XClientMessageEvent	cm;

	A = XInternAtom(display, "Main-XK", False);

	cm.type = ClientMessage;
	cm.display= display;
	cm.window = window;
	cm.message_type = A;
	cm.format = 32;
	cm.data.l[0] = key;
	XSendEvent(display, window, False, NoEventMask, &cm);
}

SendPagerAllDraw(Display *display, Window window)
{
	Atom				A;
	XClientMessageEvent	cm;

	A = XInternAtom(display, "Pager-AllDraw", False);

	cm.type = ClientMessage;
	cm.display= display;
	cm.window = window;
	cm.message_type = A;
	cm.format = 32;
	XSendEvent(display, window, False, NoEventMask, &cm);
}

SendMenuAllDraw(Display *display, Window window)
{
	Atom				A;
	XClientMessageEvent	cm;

	A = XInternAtom(display, "Menu-AllDraw", False);

	cm.type = ClientMessage;
	cm.display= display;
	cm.window = window;
	cm.message_type = A;
	cm.format = 32;
	XSendEvent(display, window, False, NoEventMask, &cm);
}

SendScrollAllDraw(Display *display, Window window)
{
	Atom				A;
	XClientMessageEvent	cm;

	A = XInternAtom(display, "Scroll-AllDraw", False);

	cm.type = ClientMessage;
	cm.display= display;
	cm.window = window;
	cm.message_type = A;
	cm.format = 32;
	XSendEvent(display, window, False, NoEventMask, &cm);
}
