#include <string.h>
#include <stdio.h>
#include <jcode.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/X.h>
#include <X11/keysym.h>
#include <X11/Xlocale.h>
#include "TPager.h"
#include "getstr.h"
#include "rman.h"

TMenu(Display *display, struct PAGER *Pager, struct MENUWIN *MenuWin, struct MENU *Menu, XEvent *event)
{
	int		i, j;

	if (event->type == EnterNotify){
		if (event->xcrossing.window == MenuWin->exit)
			XSetWindowBorder(display, MenuWin->exit, MenuWin->TitlFG);

		for ( i = 0 ; i <= MenuWin->YY-1 ; i++ ){
			for ( j = 0 ; j <= MenuWin->XX-1 ; j++ ){
				if ( i*MenuWin->XX+j > MenuWin->file_last_no ) return;
				if (event->xcrossing.window == MenuWin->sw[i*MenuWin->XX+j]){
					XSetWindowBorder(display, MenuWin->sw[i*MenuWin->XX+j] , MenuWin->FG);
				}
			}
		}
		return;
	}

	if (event->type == LeaveNotify){
		if (event->xcrossing.window == MenuWin->exit)
			XSetWindowBorder(display, MenuWin->exit, MenuWin->TitlBG);
		for ( i = 0 ; i <= MenuWin->YY-1 ; i++ ){
			for ( j = 0 ; j <= MenuWin->XX-1 ; j++ ){
				if (event->xcrossing.window == MenuWin->sw[i*MenuWin->XX+j]){
					XSetWindowBorder(display, MenuWin->sw[i*MenuWin->XX+j] , MenuWin->BG);
				}
			}
		}
		return;
	}

	if (event->type == ButtonPress){
		if (event->xany.window == MenuWin->exit && event->xbutton.button == 3){
			SendExit(display, Pager->window);
			return;
		}
		for ( i = 0 ; i <= MenuWin->XX*MenuWin->YY-1 ; i++){
			if (event->xany.window == MenuWin->sw[i]){
				SendChangeText(display, Pager,i);
				/*
				SendMenuAllDraw(display, MenuWin->sw[0]);
				*/
				return;
			}
		}
	}

	if (event->type == ClientMessage){
		if (event->xclient.message_type == XInternAtom(display, "Menu-AllDraw", False)){
			TMenuAllDraw(display, MenuWin, Menu);
			return;
		}
	}

	if (event->type == Expose){
		TMenuExpose(display, MenuWin, Menu, event->xany.window);
		return;
	}
}

TMenuExpose(Display *display, struct MENUWIN *MenuWin, struct MENU *Menu, Window event_win)
{
	int		i;
	
	if (event_win == MenuWin->title){
		XClearWindow(display, MenuWin->title);
		XmbDrawString(display, MenuWin->title, MenuWin->fs, MenuWin->TitlGC, 1, 15, MenuWin->titlemes, strlen(MenuWin->titlemes));
		return;
	}

	for (i = 0 ; i <= MenuWin->file_last_no ; i++){
		if ( event_win == MenuWin->sw[i] ){
			if (i == MenuWin->file_no){
				XSetWindowBackground(display, MenuWin->sw[MenuWin->file_no], MenuWin->FG);
				XClearWindow(display, MenuWin->sw[MenuWin->file_no]);
				XmbDrawString(display, MenuWin->sw[MenuWin->file_no], MenuWin->fs, MenuWin->MenuRevGC, 0, 15, Menu[MenuWin->file_no].title, strlen(Menu[MenuWin->file_no].title));
			}else{
				XSetWindowBackground(display, MenuWin->sw[i], MenuWin->BG);
				XClearWindow(display, MenuWin->sw[i]);
				XmbDrawString(display, MenuWin->sw[i], MenuWin->fs, MenuWin->gc, 0, 15, Menu[i].title, strlen(Menu[i].title));
			}
			return;
		}
	}
}

TMenuAllDraw(Display *display, struct MENUWIN *MenuWin, struct MENU *Menu)
{
	int		i;
	
	XClearWindow(display, MenuWin->title);
	XmbDrawString(display, MenuWin->title, MenuWin->fs, MenuWin->TitlGC, 1, 15, MenuWin->titlemes, strlen(MenuWin->titlemes));

	for (i = 0 ; i <= MenuWin->file_last_no ; i++){
		if (i == MenuWin->file_no){
			XSetWindowBackground(display, MenuWin->sw[MenuWin->file_no], MenuWin->FG);
			XClearWindow(display, MenuWin->sw[MenuWin->file_no]);
			XmbDrawString(display, MenuWin->sw[MenuWin->file_no], MenuWin->fs, MenuWin->MenuRevGC, 0, 15, Menu[MenuWin->file_no].title, strlen(Menu[MenuWin->file_no].title));
		}else{
			XSetWindowBackground(display, MenuWin->sw[i], MenuWin->BG);
			XClearWindow(display, MenuWin->sw[i]);
			XmbDrawString(display, MenuWin->sw[i], MenuWin->fs, MenuWin->gc, 0, 15, Menu[i].title, strlen(Menu[i].title));
		}
	}
	for ( i = MenuWin->file_last_no+1 ; i < MenuWin->XX*MenuWin->YY-1 ; i++ ){
		XSetWindowBackground(display, MenuWin->sw[i], MenuWin->BG);
		XClearWindow(display, MenuWin->sw[i]);
	}
}
